﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using HolePunchClient.Properties;

namespace HolePunchClient
{
    public partial class Form1 : Form
    {
        private string _guid = Guid.NewGuid().ToString();
        private IPEndPoint _holePunchServer;
        private int _holePunchServerPort = Settings.Default.SERVER_PORT;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //IPHostEntry ipHost = Dns.GetHostEntry(Settings.Default.SERVER_HOST);
            //foreach (var address in ipHost.AddressList)
            //{
            //    if (address.AddressFamily == AddressFamily.InterNetwork)
            //    {
            //        _holePunchServer = new IPEndPoint(address, _holePunchServerPort);
            //        break;
            //    }
            //}

            //IPAddress ip = IPAddress.Parse("115.90.156.67");
            //IDTextBox.Text = "ClientA";

            //ServerAddressTextBox.Text = "115.90.156.67";
            ServerAddressTextBox.Text = "175.126.145.167";
            IPAddress ip = IPAddress.Parse(ServerAddressTextBox.Text);

            _holePunchServer = new IPEndPoint(ip, _holePunchServerPort);
        }

        private UdpClient _udpClient = new UdpClient();

        private void btnPunch_Click(object sender, EventArgs e)
        {
            string uid = Environment.MachineName;
            //string uid = IDTextBox.Text;

            byte[] uidBytes = Encoding.UTF8.GetBytes(uid);

            _udpClient.Send(uidBytes, uidBytes.Length, _holePunchServer);
            _udpClient.BeginReceive(udpReceiveCallback, _udpClient);
        }

        public static Bitmap ByteToImage(byte[] blob)
        {
            MemoryStream mStream = new MemoryStream();
            byte[] pData = blob;
            mStream.Write(pData, 0, Convert.ToInt32(pData.Length));
            Bitmap bm = new Bitmap(mStream, false);
            mStream.Dispose();
            return bm;
        }

        private bool isSendedTestMessage = false;

        private void udpReceiveCallback(IAsyncResult ar)
        {
            try
            {
                UdpClient udpSocket = ar.AsyncState as UdpClient;
                IPEndPoint remoteEndPoint = null;

                byte[] receiveBytes = udpSocket.EndReceive(ar, ref remoteEndPoint);
                Debug.Write(receiveBytes.Length + "\r\n");
                //일단 byte가 10000보다 크면 이미지로 판단한다.
                //나중에 바꿀것
                if (receiveBytes.Length > 5000)
                {
                    var receiveimage = ByteToImage(receiveBytes);

                    this.BeginInvoke(
                               new MethodInvoker(delegate()
                               {
                                   pictureBox1.Image = receiveimage;
                               }));

                    udpSocket.BeginReceive(udpReceiveCallback, udpSocket);
                    return;
                }

                string receiveData = Encoding.UTF8.GetString(receiveBytes);

                string[] command = receiveData.Split(new char[] { '$', ',' }, StringSplitOptions.RemoveEmptyEntries);
                if (command.Length != 0)
                {
                    string output = string.Empty;
                    if (command[0] == "ACK")
                    {
                        output = "Ack";
                    }
                    else if (command[0] == "LIST")
                    {
                        output = "LIST == ";
                        for (int i = 1; i < command.Length; i++)
                        {
                            string[] txt = command[i].Split(new char[] { ':' }, StringSplitOptions.RemoveEmptyEntries);
                            if (txt[0] == Environment.MachineName)
                            //if (txt[0] == IDTextBox.Text)
                            {
                                continue;
                            }

                            output += txt[0] + ": " + txt[1] + " : " + txt[2];

                            this.BeginInvoke(
                                new MethodInvoker(delegate()
                                {
                                    txtUdpAddress.Text = txt[1];
                                    txtUdpPort.Text = txt[2];

                                    //만약 연결이 되면 서로에게 확인 메세지를 보내본다.
                                    if (isSendedTestMessage == false)
                                    {
                                        SendMessage("접속 테스트를 위해서 한번만 메시지를 보내봅니다.");
                                        //if (IPAddress.TryParse(txtUdpAddress.Text, out ipAddress) == true)
                                        //{
                                        //    port = Int32.Parse(txtUdpPort.Text);
                                        //    ThreadPool.QueueUserWorkItem((WaitCallback)waitCallback);
                                        //}
                                        isSendedTestMessage = true;
                                    }
                                }));
                        }
                    }
                    else if (command[0] == "DATA")
                    {
                        output = "Peer Chat: " + command[1];
                    }
                    this.BeginInvoke(
                        new MethodInvoker(delegate()
                    {
                        if (command[0] == "DATA")
                        {
                            this.MSGTextBox.Items.Add(output);
                            this.MSGTextBox.SelectedIndex = this.MSGTextBox.Items.Count - 1;
                        }
                        else
                        {
                            this.listBox1.Items.Add("Received: " + output);
                            this.listBox1.SelectedIndex = this.listBox1.Items.Count - 1;
                        }
                    }));
                }

                udpSocket.BeginReceive(udpReceiveCallback, udpSocket);
            }
            catch { }
        }

        private IPAddress ipAddress;
        private int port;

        private void btnSend_Click(object sender, EventArgs e)
        {
            if (IPAddress.TryParse(txtUdpAddress.Text, out ipAddress) == true)
            {
                port = Int32.Parse(txtUdpPort.Text);
                ThreadPool.QueueUserWorkItem((WaitCallback)waitCallback);
            }
        }

        private void waitCallback(object state)
        {
            string data = "DATA$Test Data: " + DateTime.UtcNow.ToString();
            byte[] dataContents = Encoding.UTF8.GetBytes(data);

            IPEndPoint directClient = new IPEndPoint(ipAddress, port);
            int sentBytes = _udpClient.Send(dataContents, dataContents.Length, directClient);

            Thread.Sleep(3000);
            ThreadPool.QueueUserWorkItem((WaitCallback)waitCallback);
            _count++;
        }

        private int _count;

        private void timer1_Tick(object sender, EventArgs e)
        {
            txtTimer.Text = _count.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte[] imageBytes = File.ReadAllBytes("image.jpg");
            IPAddress.TryParse(txtUdpAddress.Text, out ipAddress);
            port = Int32.Parse(txtUdpPort.Text);

            IPEndPoint directClient = new IPEndPoint(ipAddress, port);
            int sentBytes = _udpClient.Send(imageBytes, imageBytes.Length, directClient);
        }

        private void SendMessageBtn_Click(object sender, EventArgs e)
        {
            SendMessage(MessageTextBox.Text);
        }

        private void SendMessage(string msg)
        {
            string data = "DATA$Test Data: " + msg;

            byte[] dataContents = Encoding.UTF8.GetBytes(data);

            IPAddress.TryParse(txtUdpAddress.Text, out ipAddress);
            port = Int32.Parse(txtUdpPort.Text);

            IPEndPoint directClient = new IPEndPoint(ipAddress, port);
            int sentBytes = _udpClient.Send(dataContents, dataContents.Length, directClient);
        }

        private void OpenBtn_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            if (open.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                FilePathTextBox.Text = open.FileName;
            }
        }

        private void SendImageBtn_Click(object sender, EventArgs e)
        {
            if (FilePathTextBox.Text == string.Empty)
                return;

            byte[] imageBytes = File.ReadAllBytes(FilePathTextBox.Text);
            IPAddress.TryParse(txtUdpAddress.Text, out ipAddress);
            port = Int32.Parse(txtUdpPort.Text);

            IPEndPoint directClient = new IPEndPoint(ipAddress, port);

            if (imageBytes.Length > 65536)
            {
                MessageBox.Show("파일크기는 65kb이하만 가능합니다.");
                return;
            }

            int sentBytes = _udpClient.Send(imageBytes, imageBytes.Length, directClient);
        }
    }
}